3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
22 wt_prefix=$(git rev-parse --show-prefix)
25 # Restrict ourselves to a vanilla subset of protocols; the URLs
26 # we get are under control of a remote repository, and we do not
27 # want them kicking off arbitrary git-remote-* programs.
29 # If the user has already specified a set of allowed protocols,
30 # we assume they know what they're doing and use that instead.
31 : ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
32 export GIT_ALLOW_PROTOCOL
49 # The function takes at most 2 arguments. The first argument is the
50 # URL that navigates to the submodule origin repo. When relative, this URL
51 # is relative to the superproject origin URL repo. The second up_path
52 # argument, if specified, is the relative path that navigates
53 # from the submodule working tree to the superproject working tree.
55 # The output of the function is the origin URL of the submodule.
57 # The output will either be an absolute URL or filesystem path (if the
58 # superproject origin URL is an absolute URL or filesystem path,
59 # respectively) or a relative file system path (if the superproject
60 # origin URL is a relative file system path).
62 # When the output is a relative file system path, the path is either
63 # relative to the submodule working tree, if up_path is specified, or to
64 # the superproject working tree otherwise.
65 resolve_relative_url ()
67 remote=$(get_default_remote)
68 remoteurl=$(git config "remote.$remote.url") ||
69 remoteurl=$(pwd) # the repository is its own authoritative upstream
71 remoteurl=${remoteurl%/}
84 remoteurl="./$remoteurl"
95 remoteurl="${remoteurl%/*}"
98 remoteurl="${remoteurl%:*}"
102 if test -z "$is_relative" || test "." = "$remoteurl"
104 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
118 remoteurl="$remoteurl$sep${url%/}"
119 echo "${is_relative:+${up_path}}${remoteurl#./}"
122 # Resolve a path to be relative to another path. This is intended for
123 # converting submodule paths when git-submodule is run in a subdirectory
124 # and only handles paths where the directory separator is '/'.
126 # The output is the first argument as a path relative to the second argument,
127 # which defaults to $wt_prefix if it is omitted.
130 local target curdir result
132 curdir=${2-$wt_prefix}
136 while test -n "$curdir"
140 target=${target#"$curdir"/}
145 result="${result}../"
146 if test "$curdir" = "${curdir%/*}"
150 curdir="${curdir%/*}"
154 echo "$result$target"
159 if test "$1" = "#unmatched"
166 # Print a submodule configuration setting
168 # $1 = submodule name
172 # Checks in the usual git-config places first (for overrides),
173 # otherwise it falls back on .gitmodules. This allows you to
174 # distribute project-wide defaults in .gitmodules, while still
175 # customizing individual repositories if necessary. If the option is
176 # not in .gitmodules either, print a default value.
178 get_submodule_config () {
182 value=$(git config submodule."$name"."$option")
185 value=$(git config -f .gitmodules submodule."$name"."$option")
187 printf '%s' "${value:-$default}"
192 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
196 # Add a new submodule to the working tree, .gitmodules and the index
200 # optional branch is stored in global branch variable
204 # parse $args after "submodule ... add".
210 case "$2" in '') usage ;; esac
221 case "$2" in '') usage ;; esac
226 reference_path="${1#--reference=}"
229 case "$2" in '') usage ;; esac
234 case "$2" in '') usage ;; esac
255 if test -n "$reference_path"
257 is_absolute_path "$reference_path" ||
258 reference_path="$wt_prefix$reference_path"
260 reference="--reference=$reference_path"
266 if test -z "$sm_path"; then
267 sm_path=$(printf '%s\n' "$repo" |
268 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
271 if test -z "$repo" || test -z "$sm_path"; then
275 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
277 # assure repo is absolute or relative to parent
280 test -z "$wt_prefix" ||
281 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
283 # dereference source url relative to parent's url
284 realrepo=$(resolve_relative_url "$repo") || exit
291 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
296 # multiple //; leading ./; /./; /../; trailing /
297 sm_path=$(printf '%s/\n' "$sm_path" |
307 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
308 die "$(eval_gettext "'\$sm_path' already exists in the index")"
310 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
312 eval_gettextln "The following path is ignored by one of your .gitignore files:
314 Use -f if you really want to add it." >&2
318 if test -n "$custom_name"
320 sm_name="$custom_name"
325 # perhaps the path exists and is already a git repo, else clone it
326 if test -e "$sm_path"
328 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
330 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
332 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
336 if test -d ".git/modules/$sm_name"
340 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
341 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
342 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
343 echo >&2 " $realrepo"
344 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
345 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
347 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
350 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" "$reference" "$depth" || exit
354 # ash fails to wordsplit ${branch:+-b "$branch"...}
356 '') git checkout -f -q ;;
357 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
359 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
361 git config submodule."$sm_name".url "$realrepo"
363 git add $force "$sm_path" ||
364 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
366 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
367 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
370 git config -f .gitmodules submodule."$sm_name".branch "$branch"
372 git add --force .gitmodules ||
373 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
377 # Execute an arbitrary command sequence in each checked out
380 # $@ = command to execute
384 # parse $args after "submodule ... foreach".
406 # dup stdin so that it can be restored when running the external
407 # command in the subshell (and a recursive call to this function)
410 git submodule--helper list --prefix "$wt_prefix"|
411 while read mode sha1 stage sm_path
413 die_if_unmatched "$mode"
414 if test -e "$sm_path"/.git
416 displaypath=$(relative_path "$sm_path")
417 say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
418 name=$(git submodule--helper name "$sm_path")
420 prefix="$prefix$sm_path/"
423 sm_path=$(relative_path "$sm_path") &&
424 # we make $path available to scripts ...
432 if test -n "$recursive"
434 cmd_foreach "--recursive" "$@"
437 die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
443 # Register submodules in .git/config
445 # $@ = requested paths (default to all)
449 # parse $args after "submodule ... init".
470 git submodule--helper list --prefix "$wt_prefix" "$@" |
471 while read mode sha1 stage sm_path
473 die_if_unmatched "$mode"
474 name=$(git submodule--helper name "$sm_path") || exit
476 displaypath=$(relative_path "$sm_path")
478 # Copy url setting when it is not set yet
479 if test -z "$(git config "submodule.$name.url")"
481 url=$(git config -f .gitmodules submodule."$name".url)
483 die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
485 # Possibly a url relative to parent
488 url=$(resolve_relative_url "$url") || exit
491 git config submodule."$name".url "$url" ||
492 die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
494 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
497 # Copy "update" setting when it is not set yet
498 if upd="$(git config -f .gitmodules submodule."$name".update)" &&
500 test -z "$(git config submodule."$name".update)"
503 checkout | rebase | merge | none)
504 ;; # known modes of updating
506 echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
510 git config submodule."$name".update "$upd" ||
511 die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
517 # Unregister submodules from .git/config and remove their work tree
519 # $@ = requested paths (use '.' to deinit all submodules)
523 # parse $args after "submodule ... deinit".
549 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
552 git submodule--helper list --prefix "$wt_prefix" "$@" |
553 while read mode sha1 stage sm_path
555 die_if_unmatched "$mode"
556 name=$(git submodule--helper name "$sm_path") || exit
558 displaypath=$(relative_path "$sm_path")
560 # Remove the submodule work tree (unless the user already did it)
561 if test -d "$sm_path"
563 # Protect submodules containing a .git directory
564 if test -d "$sm_path/.git"
566 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
567 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
572 git rm -qn "$sm_path" ||
573 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
576 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
577 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
580 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
582 # Remove the .git/config entries (unless the user already did it)
583 if test -n "$(git config --get-regexp submodule."$name\.")"
585 # Remove the whole section so we have a clean state when
586 # the user later decides to init this submodule again
587 url=$(git config submodule."$name".url)
588 git config --remove-section submodule."$name" 2>/dev/null &&
589 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
594 is_tip_reachable () (
597 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
601 fetch_in_submodule () (
608 git fetch $(get_default_remote) "$2" ;;
613 # Update each submodule path to correct revision, using clone and checkout as needed
615 # $@ = requested paths (default to all)
619 # parse $args after "submodule ... update".
642 case "$2" in '') usage ;; esac
643 reference="--reference=$2"
659 case "$2" in '') usage ;; esac
682 cmd_init "--" "$@" || return
686 git submodule--helper list --prefix "$wt_prefix" "$@" | {
688 while read mode sha1 stage sm_path
690 die_if_unmatched "$mode"
693 echo >&2 "Skipping unmerged submodule $prefix$sm_path"
696 name=$(git submodule--helper name "$sm_path") || exit
697 url=$(git config submodule."$name".url)
698 branch=$(get_submodule_config "$name" branch master)
699 if ! test -z "$update"
701 update_module=$update
703 update_module=$(git config submodule."$name".update)
704 if test -z "$update_module"
706 update_module="checkout"
710 displaypath=$(relative_path "$prefix$sm_path")
712 if test "$update_module" = "none"
714 echo "Skipping submodule '$displaypath'"
720 # Only mention uninitialized submodules when its
721 # path have been specified
723 say "$(eval_gettext "Submodule path '\$displaypath' not initialized
724 Maybe you want to use 'update --init'?")"
728 if ! test -d "$sm_path"/.git && ! test -f "$sm_path"/.git
730 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$prefix" --path "$sm_path" --name "$name" --url "$url" "$reference" "$depth" || exit
731 cloned_modules="$cloned_modules;$name"
734 subsha1=$(clear_local_git_env; cd "$sm_path" &&
735 git rev-parse --verify HEAD) ||
736 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
741 if test -z "$nofetch"
743 # Fetch remote before determining tracking $sha1
744 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
745 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
747 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
748 sha1=$(clear_local_git_env; cd "$sm_path" &&
749 git rev-parse --verify "${remote_name}/${branch}") ||
750 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
753 if test "$subsha1" != "$sha1" || test -n "$force"
756 # If we don't already have a -f flag and the submodule has never been checked out
757 if test -z "$subsha1" && test -z "$force"
762 if test -z "$nofetch"
764 # Run fetch only if $sha1 isn't present or it
765 # is not reachable from a ref.
766 is_tip_reachable "$sm_path" "$sha1" ||
767 fetch_in_submodule "$sm_path" ||
768 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
770 # Now we tried the usual fetch, but $sha1 may
771 # not be reachable from any of the refs
772 is_tip_reachable "$sm_path" "$sha1" ||
773 fetch_in_submodule "$sm_path" "$sha1" ||
774 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain $sha1. Direct fetching of that commit failed.")"
777 # Is this something we just cloned?
778 case ";$cloned_modules;" in
780 # then there is no local change to integrate
781 update_module=checkout ;;
785 case "$update_module" in
787 command="git checkout $subforce -q"
788 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
789 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
793 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
794 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
795 must_die_on_failure=yes
799 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
800 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
801 must_die_on_failure=yes
804 command="${update_module#!}"
805 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
806 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
807 must_die_on_failure=yes
810 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
813 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
816 elif test -n "$must_die_on_failure"
818 die_with_status 2 "$die_msg"
820 err="${err};$die_msg"
825 if test -n "$recursive"
828 prefix="$prefix$sm_path/"
836 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
839 err="${err};$die_msg"
842 die_with_status $res "$die_msg"
869 git describe "$2" 2>/dev/null ||
870 git describe --tags "$2" 2>/dev/null ||
871 git describe --contains "$2" 2>/dev/null ||
872 git describe --all --always "$2"
875 test -z "$revname" || revname=" ($revname)"
878 # Show commit summary for submodules in index or working tree
880 # If '--cached' is given, show summary between index and given commit,
881 # or between working tree and given commit
883 # $@ = [commit (default 'HEAD'),] requested paths (default all)
890 # parse $args after "submodule ... summary".
905 isnumber "$summary_limit" || usage
909 summary_limit="${1#--summary-limit=}"
910 isnumber "$summary_limit" || usage
926 test $summary_limit = 0 && return
928 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
932 elif test -z "$1" || test "$1" = "HEAD"
934 # before the first commit: compare with an empty tree
935 head=$(git hash-object -w -t tree --stdin </dev/null)
936 test -z "$1" || shift
944 die "$(gettext "The --cached option cannot be used with the --files option")"
950 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
951 # Get modified modules cared by user
952 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
953 sane_egrep '^:([0-7]* )?160000' |
954 while read mod_src mod_dst sha1_src sha1_dst status sm_path
956 # Always show modules deleted or type-changed (blob<->module)
957 if test "$status" = D || test "$status" = T
959 printf '%s\n' "$sm_path"
962 # Respect the ignore setting for --for-status.
963 if test -n "$for_status"
965 name=$(git submodule--helper name "$sm_path")
966 ignore_config=$(get_submodule_config "$name" ignore none)
967 test $status != A && test $ignore_config = all && continue
969 # Also show added or modified modules which are checked out
970 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
971 printf '%s\n' "$sm_path"
975 test -z "$modules" && return
977 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
978 sane_egrep '^:([0-7]* )?160000' |
980 while read mod_src mod_dst sha1_src sha1_dst status name
982 if test -z "$cached" &&
983 test $sha1_dst = 0000000000000000000000000000000000000000
987 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
989 100644 | 100755 | 120000)
990 sha1_dst=$(git hash-object $name)
996 eval_gettextln "unexpected mode \$mod_dst" >&2
1003 test $mod_src = 160000 &&
1004 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1007 test $mod_dst = 160000 &&
1008 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1011 display_name=$(relative_path "$name")
1014 case "$missing_src,$missing_dst" in
1016 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1019 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1022 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1027 if test $mod_src = 160000 && test $mod_dst = 160000
1029 range="$sha1_src...$sha1_dst"
1030 elif test $mod_src = 160000
1036 GIT_DIR="$name/.git" \
1037 git rev-list --first-parent $range -- | wc -l
1039 total_commits=" ($(($total_commits + 0)))"
1043 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1044 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1047 blob="$(gettext "blob")"
1048 submodule="$(gettext "submodule")"
1049 if test $mod_dst = 160000
1051 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1053 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1056 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1058 if test -n "$errmsg"
1060 # Don't give error msg for modification whose dst is not submodule
1061 # i.e. deleted or changed to blob
1062 test $mod_dst = 160000 && echo "$errmsg"
1064 if test $mod_src = 160000 && test $mod_dst = 160000
1067 test $summary_limit -gt 0 && limit="-$summary_limit"
1068 GIT_DIR="$name/.git" \
1069 git log $limit --pretty='format: %m %s' \
1070 --first-parent $sha1_src...$sha1_dst
1071 elif test $mod_dst = 160000
1073 GIT_DIR="$name/.git" \
1074 git log --pretty='format: > %s' -1 $sha1_dst
1076 GIT_DIR="$name/.git" \
1077 git log --pretty='format: < %s' -1 $sha1_src
1085 # List all submodules, prefixed with:
1086 # - submodule not initialized
1087 # + different revision checked out
1089 # If --cached was specified the revision in the index will be printed
1090 # instead of the currently checked out revision.
1092 # $@ = requested paths (default to all)
1096 # parse $args after "submodule ... status".
1123 git submodule--helper list --prefix "$wt_prefix" "$@" |
1124 while read mode sha1 stage sm_path
1126 die_if_unmatched "$mode"
1127 name=$(git submodule--helper name "$sm_path") || exit
1128 url=$(git config submodule."$name".url)
1129 displaypath=$(relative_path "$prefix$sm_path")
1130 if test "$stage" = U
1132 say "U$sha1 $displaypath"
1135 if test -z "$url" ||
1137 ! test -d "$sm_path"/.git &&
1138 ! test -f "$sm_path"/.git
1141 say "-$sha1 $displaypath"
1144 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1146 set_name_rev "$sm_path" "$sha1"
1147 say " $sha1 $displaypath$revname"
1149 if test -z "$cached"
1151 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
1153 set_name_rev "$sm_path" "$sha1"
1154 say "+$sha1 $displaypath$revname"
1157 if test -n "$recursive"
1160 prefix="$displaypath/"
1165 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1170 # Sync remote urls for submodules
1171 # This makes the value for remote.$remote.url match the value
1172 # specified in .gitmodules.
1200 git submodule--helper list --prefix "$wt_prefix" "$@" |
1201 while read mode sha1 stage sm_path
1203 die_if_unmatched "$mode"
1204 name=$(git submodule--helper name "$sm_path")
1205 url=$(git config -f .gitmodules --get submodule."$name".url)
1207 # Possibly a url relative to parent
1210 # rewrite foo/bar as ../.. to find path from
1211 # submodule work tree to superproject work tree
1212 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1213 # guarantee a trailing /
1214 up_path=${up_path%/}/ &&
1215 # path from submodule work tree to submodule origin repo
1216 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1217 # path from superproject work tree to submodule origin repo
1218 super_config_url=$(resolve_relative_url "$url") || exit
1221 sub_origin_url="$url"
1222 super_config_url="$url"
1226 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1228 displaypath=$(relative_path "$prefix$sm_path")
1229 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1230 git config submodule."$name".url "$super_config_url"
1232 if test -e "$sm_path"/.git
1237 remote=$(get_default_remote)
1238 git config remote."$remote".url "$sub_origin_url"
1240 if test -n "$recursive"
1242 prefix="$prefix$sm_path/"
1251 # This loop parses the command line arguments to find the
1252 # subcommand name to dispatch. Parsing of the subcommand specific
1253 # options are primarily done by the subcommand implementations.
1254 # Subcommand specific options such as --branch and --cached are
1255 # parsed here as well, for backward compatibility.
1257 while test $# != 0 && test -z "$command"
1260 add | foreach | init | deinit | update | status | summary | sync)
1290 # No command word defaults to "status"
1291 if test -z "$command"
1301 # "-b branch" is accepted only by "add"
1302 if test -n "$branch" && test "$command" != add
1307 # "--cached" is accepted only by "status" and "summary"
1308 if test -n "$cached" && test "$command" != status && test "$command" != summary